import { world, ItemStack } from "@minecraft/server";

// Function to check if the player is holding a shield
function isHoldingShield(player) {
    const Mainhand = player.getComponent("minecraft:equippable").getEquipment("Mainhand");
    const Offhand = player.getComponent("minecraft:equippable").getEquipment("Offhand");
    return (Mainhand && Mainhand.typeId === "minecraft:shield") || (Offhand && Offhand.typeId === "minecraft:shield");
}
function applyShieldCooldown(player) {
    const Mainhand = player.getComponent("minecraft:equippable").getEquipment("Mainhand");
    const Offhand = player.getComponent("minecraft:equippable").getEquipment("Offhand");
    if (Mainhand && Mainhand.typeId === "minecraft:shield") {
        const cooldownComponent = Mainhand.getComponent("cooldown");
        if (cooldownComponent) {
            cooldownComponent.startCooldown(player);
        }
    }
    if (Offhand && Offhand.typeId === "minecraft:shield") {
        const cooldownComponent = Offhand.getComponent("cooldown");
        if (cooldownComponent) {
            cooldownComponent.startCooldown(player);
        }
    }
}

// Subscribe to the event when a projectile hits an entity
world.afterEvents.projectileHitEntity.subscribe((event) => {
    const projectile = event.projectile;
    // Check if the projectile has the specified ID
    if (projectile && projectile.typeId === "drg:boulderling_rock") {
        // Check if the entity hit is a player
        const player = event.getEntityHit().entity;
        if (player && player.isValid() && player.typeId === "minecraft:player") {
            // Check if the player is sneaking (defending) and holding a shield
            if (player.isSneaking && isHoldingShield(player)) {
                // Apply cooldown to the shield
                applyShieldCooldown(player);
            }
        }
    }
});
